dnl Usage:
dnl GLITE_SERVICE_DISCOVERY
dnl - GLITE_SERVICE_DISCOVERY_API_C_LDFLAGS
dnl - GLITE_SERVICE_DISCOVERY_API_C_LIBS
dnl - GLITE_SERVICE_DISCOVERY_API_C_CFLAGS

AC_DEFUN([GLITE_SERVICE_DISCOVERY],
[
    glite_sd_prefix=$GLITE_LOCATION
    
    dnl Check that the service-discovery.api-c package is available
    save_CPPFLAGS="$CPPFLAGS"
    save_LDFLAGS="$LDFLAGS"
    save_LIBS="$LIBS"

    ac_glite_sd_libdir='lib'
    if test `uname -s` = "Linux"
    then
      # patch linux on power, mips, Itanium and intel 
      for a in x86_64 powerpc ppc64 mips ia64
      do 
        if test `uname -p` = $a 
        then  
          ac_glite_sd_libdir='lib64'
        fi 

        if test `uname -m` = $a 
        then  
          ac_glite_sd_libdir='lib64'
        fi 
      done
    fi

    # special cases (hyperlink lib64, Debian)
    if test -h /usr/lib64
    then
      ac_glite_sd_libdir='lib'
    fi
    
    # if /usr/lib64 doesn't exist at all (AIX)
    if ! test -e /usr/lib64
    then
      ac_glite_sd_libdir='lib'
    fi

    if test `uname -s` = "SunOS"
    then
      if test -e "/usr/lib/64"
      then
        ac_glite_sd_libdir='lib/64'
      fi
    fi

    GLITE_SERVICE_DISCOVERY_API_C_CFLAGS="-I$glite_sd_prefix/include"
    CPPFLAGS="$CPPFLAGS $GLITE_SERVICE_DISCOVERY_API_C_CFLAGS"
    GLITE_SERVICE_DISCOVERY_API_C_LDFLAGS="-L$glite_sd_prefix/$ac_glite_sd_libdir"
    GLITE_SERVICE_DISCOVERY_API_C_LIBS="$GLITE_SERVICE_DISCOVERY_API_C_LDFLAGS -lglite-sd-c"
    LDFLAGS="$LDFLAGS $GLITE_SERVICE_DISCOVERY_API_C_LDFLAGS"
    AC_CHECK_HEADER([ServiceDiscovery.h],,
        [AC_MSG_ERROR([Headers from the org.glite.service-discovery.api-c package are not available])])
    AC_CHECK_LIB([glite-sd-c],[SD_getService],,
        [AC_MSG_ERROR([Libraries from the org.glite.service-discovery.api-c package are not available])])
    LIBS="$save_LIBS"
    LDFLAGS="$save_LDFLAGS"
    CPPFLAGS="$save_CPPFLAGS"

    AC_SUBST(GLITE_SERVICE_DISCOVERY_API_C_LDFLAGS)
    AC_SUBST(GLITE_SERVICE_DISCOVERY_API_C_LIBS)
    AC_SUBST(GLITE_SERVICE_DISCOVERY_API_C_CFLAGS)

    if test ${ac_glite_sd_libdir} = "lib64"
    then
      AC_SUBST([libdir],         ['${exec_prefix}/lib64'])dnl
    elif test ${ac_glite_sd_libdir} = "lib/64"
    then
      AC_SUBST([libdir],         ['${exec_prefix}/lib/64'])dnl
    else
      AC_SUBST([libdir],         ['${exec_prefix}/lib'])dnl
    fi
      
    AC_MSG_RESULT([libdir is set ${libdir}])
    AC_SUBST([mandir],         ['${prefix}/share/man'])dnl
])


dnl
dnl Backward compatibility hack: including the old macro with some
dnl update for lib64...
dnl
dnl Usage:
dnl AC_GLITE_SERVICE_DISCOVERY
dnl - GLITE_SERVICE_DISCOVERY_API_C_LIBS
dnl - GLITE_SERVICE_DISCOVERY_API_C_STATIC_LIBS

AC_DEFUN(AC_GLITE_SERVICE_DISCOVERY,
[
    ac_glite_sd_prefix=$GLITE_LOCATION

    if test -n "ac_glite_sd_prefix" ; then
	dnl
	dnl 
	dnl

        ac_glite_sd_libdir='lib'
        if test `uname -s` = "Linux"
        then
          # patch linux on power and intel 
          for a in x86_64 powerpc ppc64 mips
          do 
            if test `uname -p` = $a 
            then  
              ac_glite_sd_libdir='lib64'
            fi 
    
            if test `uname -m` = $a 
            then  
              ac_glite_sd_libdir='lib64'
            fi 
          done
        fi

        # special cases (hyperlink lib64, Debian)
        if test -h /usr/lib64
        then
          ac_glite_sd_libdir='lib'
        fi

        # if /usr/lib64 doesn't exist at all (AIX)
        if ! test -e /usr/lib64
        then
          ac_glite_sd_libdir='lib'
        fi
    
        if test `uname -s` = "SunOS"
        then
          if test -e "/usr/lib/64"
          then
            ac_glite_sd_libdir='lib/64'
          fi
        fi

        ac_glite_sd_lib="-L$ac_glite_sd_prefix/$ac_glite_sd_libdir"
	GLITE_SERVICE_DISCOVERY_API_C_LIBS="$ac_glite_sd_lib -lglite-sd-c"
	GLITE_SERVICE_DISCOVERY_API_C_STATIC_LIBS="$ac_glite_sd_prefix/lib/libglite-sd-c.a"
	ifelse([$2], , :, [$2])
    else
	GLITE_SERVICE_DISCOVERY_API_C_LIBS=""
	GLITE_SERVICE_DISCOVERY_API_C_STATIC_LIBS=""
	ifelse([$3], , :, [$3])
    fi

    AC_SUBST(GLITE_SERVICE_DISCOVERY_API_C_LIBS)
    AC_SUBST(GLITE_SERVICE_DISCOVERY_API_C_STATIC_LIBS)
])

